Package: org.codehaus.groovy.classgen

## [Java] Class VariableScopeVisitor

- org.codehaus.groovy.classgen.VariableScopeVisitor

- goes through an AST and initializes the scopes

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `def` | `VariableScopeVisitor(org.codehaus.groovy.control.SourceUnit source, boolean recurseInnerClasses)`
    `` | `def` | `VariableScopeVisitor(org.codehaus.groovy.control.SourceUnit source)`
    `` | `protected org.codehaus.groovy.control.SourceUnit` | `getSourceUnit()`
    `` | `void` | `prepareVisit(ClassNode node)` Setup the current class node context.
    `` | `void` | `visitAnnotations(AnnotatedNode node)`
    `` | `void` | `visitBinaryExpression(BinaryExpression be)`
    `` | `void` | `visitBlockStatement(BlockStatement block)`
    `` | `void` | `visitCatchStatement(CatchStatement statement)`
    `` | `void` | `visitClass(ClassNode node)`
    `` | `void` | `visitClosureExpression(ClosureExpression expression)`
    `` | `void` | `visitConstructorCallExpression(ConstructorCallExpression call)`
    `` | `protected void` | `visitConstructorOrMethod(MethodNode node, boolean isConstructor)`
    `` | `void` | `visitDeclarationExpression(DeclarationExpression expression)`
    `` | `void` | `visitField(FieldNode node)`
    `` | `void` | `visitFieldExpression(FieldExpression expression)`
    `` | `void` | `visitForLoop(ForStatement forLoop)`
    `` | `void` | `visitIfElse(IfStatement ifElse)`
    `` | `void` | `visitMethodCallExpression(MethodCallExpression call)`
    `` | `void` | `visitProperty(PropertyNode node)`
    `` | `void` | `visitPropertyExpression(PropertyExpression expression)`
    `` | `void` | `visitVariableExpression(VariableExpression expression)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitListExpression, visitListOfExpressions, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### public def VariableScopeVisitor(org.codehaus.groovy.control.SourceUnit source, boolean recurseInnerClasses)

    - #### public def VariableScopeVisitor(org.codehaus.groovy.control.SourceUnit source)

    - #### protected org.codehaus.groovy.control.SourceUnit getSourceUnit()

    - #### public void prepareVisit(ClassNode node)

      Setup the current class node context.

      Parameters:
        node

    - #### public void visitAnnotations(AnnotatedNode node)

    - #### @Override public void visitBinaryExpression(BinaryExpression be)

    - #### public void visitBlockStatement(BlockStatement block)

    - #### public void visitCatchStatement(CatchStatement statement)

    - #### public void visitClass(ClassNode node)

    - #### public void visitClosureExpression(ClosureExpression expression)

    - #### public void visitConstructorCallExpression(ConstructorCallExpression call)

    - #### protected void visitConstructorOrMethod(MethodNode node, boolean isConstructor)

    - #### public void visitDeclarationExpression(DeclarationExpression expression)

    - #### public void visitField(FieldNode node)

    - #### public void visitFieldExpression(FieldExpression expression)

    - #### public void visitForLoop(ForStatement forLoop)

    - #### public void visitIfElse(IfStatement ifElse)

    - #### public void visitMethodCallExpression(MethodCallExpression call)

    - #### public void visitProperty(PropertyNode node)

    - #### public void visitPropertyExpression(PropertyExpression expression)

    - #### public void visitVariableExpression(VariableExpression expression)